
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何用ORM支持SQL语句的CASE WHEN？ / 憋错料</title>

    <meta name="description" content="如何用ORM支持SQL语句的CASE WHEN？ OQL如何支持CASE WHEN? 今天,一个朋友问我,OQL可否支持CASE WHEN语句?他给的示例SQL如下: select HName,case when IsEnable=1 then '启用' else '停用' from tb_User OQL是SOD框架的ORM查询语言,它类似Linq,但是它诞生的历史比Linq早,并且更加接近SQL语法.所以,对SOD框架而言,对应ORM如何支持CASE WHEN,就等于是问OQL如何支持CASE WHEN了. 这个问题已经不止这一个朋友来问我">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">如何用ORM支持SQL语句的CASE WHEN？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>OQL如何支持CASE WHEN？</h1>
<p>今天，一个朋友问我，OQL可否支持CASE WHEN语句？他给的示例SQL如下：</p>
<pre>select HName,case when IsEnable=1 then ‘启用‘ else ‘停用‘ from tb_User</pre>
<p>OQL是<a href="http://www.pwmis.com/sqlmap" rel="external nofollow noreferrer">SOD框架</a>的<a href="http://www.cnblogs.com/bluedoctor/p/3225176.html" rel="external nofollow noreferrer"><strong>ORM查询语言</strong></a>，它类似Linq，但是它诞生的历史比Linq早，并且更加接近SQL语法。所以，对SOD框架而言，对应ORM如何支持CASE WHEN，就等于是问OQL如何支持CASE WHEN了。</p>
<p>这个问题已经不止这一个朋友来问我了，我想了下，还是把这个问题的解决写一篇博客，给大家一种新的解决方案。<br />注意&ldquo;新的方案&rdquo;这个提法，我是不打算让OQL支持CASE WHEN这个特性的，为何要这样做呢？</p>
<ol>
<li>QL只解决　８０％的普通查询，其它复杂的查询，应该依托于其它技术，否则会增加OQL的复杂性；</li>
<li>复杂的查询，可以借助于SOD框架的<a href="http://www.cnblogs.com/bluedoctor/p/4498066.html" rel="external nofollow noreferrer">SQL-MAP技术</a>，将SQL语句写在SqlMap.config文件中；</li>
<li>可以采用数据库视图或者计算列；</li>
</ol>
<p>前面3种原因，第2,3条方法也可以看做是此问题的解决方案，但是它们都需要增加更多的工作量，如果OQL能够直接支持还是更方便些，所以，我今天在这里给大家第4种解决方案：</p>
<h1>实体类的计算属性</h1>
<p>废话不多说，先直接看代码：</p>
<pre>public class User:EntityBase
{
  public User()
  {
      TableName="tb_User";
  }

  public string HName{
    get{return getProperty&lt;string&gt;("HName");}
    set{setProperty&lt;string&gt;("HName",value,50);}
  }

  public bool IsEnable{
    get{return getProperty&lt;bool&gt;("IsEnable");}
    set{setProperty&lt;bool&gt;("IsEnable",value);}
  }

  public string IsEnableDescrition
  {
     get{
        return IsEnable?"启用":"停用"
     }
   }

}</pre>
<p>在这里，HName,IsEnable 这样的属性，SOD框架称为&ldquo;<strong>持久化属性</strong>&rdquo;，因为它MAP了Tb_User表的字段IsEnable ,该字段称为&ldquo;<strong>持久化属性字段</strong>&rdquo;。</p>
<p>持久化属性的get,set方法采用了SOD实体类特殊的方法 setProperty,getProperty 构造，所以属性IsEnableDescription 它不是持久化属性，但是它利用了IsEnable这个持久化属性，对持久化属性进行&ldquo;计算&rdquo;，因此，我们这里称呼这样的属性为实体类的&ldquo;<strong>计算属性</strong>&rdquo;。</p>
<p>大家看看，这个&ldquo;计算属性&rdquo;是不是很好的起到了 SQL的CASE WHEN效果？</p>
<p>只要忘记了数据库，不要遇到问题就去想如何用SQL语句解决，是不是思路豁然开朗？</p>
<h1>如何使用&ldquo;计算属性&rdquo;</h1>
<p>前面说过，实体类的&ldquo;计算属性&rdquo;本质上不是一个&ldquo;持久化属性&rdquo;，它是对持久化属性的计算处理，原理上非常类似SQLServer表上面的计算列。<br />因此，在SOD框架上使用&ldquo;计算属性&rdquo;，有一个必须注意的原则：&ldquo;计算属性&rdquo;不可以出现在OQL语句中。</p>
<p>具体举例来说，应该像下面的样子来使用包含计算列的实体类：</p>
<pre>User user=new User(){ HName="张三"};
var q=OQL.From(user)
  .Select(user.HName,user.IsEnable)
  .Where(user.HName)
.END;

User user2= EntityQuery&lt;User&gt;.QueryObject(q);
string isEnableDesction =user2.isEnableDesction;</pre>
<p>有关上面SOD框架查询使用的入门介绍，大家可以参考<a href="http://www.cnblogs.com/bluedoctor/p/4306131.html" rel="external nofollow noreferrer">《.NET ORM 的 &ldquo;SOD蜜&rdquo;--零基础入门篇 》</a></p>
<p>感谢大家对SOD框架一直以来的支持，更多信息，请参考 <a href="http://www.cnblogs.com/bluedoctor/p/4290570.html" rel="external nofollow noreferrer">PDF.NET SOD 开源框架红包派送活动 &amp;&amp; 新手快速入门指引</a></p>
<p>开源项目需要大家更多的支持，SOD开源项目网站：<a href="http://pwmis.codeplex.com" rel="external nofollow noreferrer">http://pwmis.codeplex.com</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-23 02:23:44 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>如何用ORM支持SQL语句的CASE WHEN？的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/7MVwlp0.html" rel="bookmark">sql 语句之 case</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				case语句语法: --简单Case函数 CASE sex WHEN '1' THEN '男' WHEN '2' THEN '女' ELSE '其他' END --Case搜索函数 CASE WHEN sex = '1' THEN '男' WHEN sex = '2' THEN '女' ELSE '其他' END 首先创建一张users表,其中包含id,name,sex三个字段,表内容如下: 复制代码 SQL&gt; drop table users purge; drop table users p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RGA1P3.html" rel="bookmark">Oracle的sql语句中case关键字的用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				例子1: a)查询列中有&quot;_&quot;开头的列名时,需要用双引号引起来. b)使用&quot;case&quot;关键字,根据分数直接判断是否及格. create table tbl_score( id NUMBER(4), --id name varchar2(30), --名称 score NUMBER(3), --分数 otherscore NUMBER(3) --其他分数 ); select t.id as &quot;_id&quot;, t.name as name, case w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49kxDg0.html" rel="bookmark">如何用一条SQL语句从登录日志表中查询统计出每个人登录的次数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这绝对是基本功,没有任何理由说不会,甚至不知道,作为自己面壁思过的一道题 SQL: SELECT user_name, COUNT(*) as count FROM log GROUP BY user_name 如果加上HAVING则作为count数量的条件查询控制, 如:HAVING count &gt; 1; 意为,登录次数多于一次的用户及对应的登录次数.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35XrLE0.html" rel="bookmark">sql语句：CASE WHEN END 的用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				select b,c, CASE a WHEN '1' THEN '1001' WHEN '2' THEN '1002' ELSE '1003' end from test1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47BDQb3.html" rel="bookmark">求问如何用一句sql语句来代替asp&period;net的程序代码？yrsxn</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				. 种菜,选种子很重要.别买了滥情的种子,即使开花很漂亮,却结了空心的菜,最后一无所有,原因不是好友会偷菜,而是他自己跑了. 8. 如果一场爱情从开始起,就注定是一场赌博,那么谁认真的想要压上一切去赢得赌博时,谁就一定会输得精光,因为赌博里只 我记得你在昨天 豪迈的放歌 黑夜陪你一起奔腾 连星星也隐没了 日光倾城之时 有人陪你一起等待夕阳 落日的余晖映出永恒的真诚 我想要定格成永远,只有你的脸 却憾恨着不能不说再见 你,是我逝去的记忆 似水流年,流转着温暖 檐下的花儿静静开,夜风似影久等在门外.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lW7lXM.html" rel="bookmark">SQL语句删除表中所有记录的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何用一条sql语句删除表中的所有记录,这里分享下我的方法.参考链接: sql语句如何删除重复记录?四种方法 sql语句如何删除重复记录?教程详解 TRUNCATE TABLE删除表中的所有行,而不记录单个行删除操作. 语法TRUNCATE TABLE name 参数name 是要截断的表的名称或要删除其全部行的表的名称. 注释TRUNCATE TABLE 在功能上与不带 WHERE 子句的 DELETE 语句相同:二者均删除表中的全部行.但 TRUNCATE TABLE 比 DELETE 速度			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bZvKv0.html" rel="bookmark">java执行多条SQL语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一次执行多条SQL的技术要点如下: DatabaseMetaData接口是描述有关数据库的整体综合信息,由于DatabaseMetaData是接口,所以没有构造方法,故不能使用new来创建DatabaseMetaData对象,但是可以通过Connection的getMetaData()方法创建.例如:DatabaseMetaData md=con.getMetaData(). DatabaseMetaData类的supportsBatchUpdates方法用于判断此数据库是否支持批量更新.其返回			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBELLv4.html" rel="bookmark">C&num;代码验证sql语句是否正确&lpar;只验证不执行sql&rpar;的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自 :http://www.jquerycn.cn/a_15010 为大家介绍如何用C#验证sql语句的正确性,就像sql查询分析器中的检测代码功能一样,有需要的朋友,可以参考下. 需要用到如下的知识:SET PARSEONLY检查每个 Transact-SQL 语句的语法并返回任何错误消息,但不编译和执行语句.SET PARSEONLY { ON | OFF }当 SET PARSEONLY 为 ON 时,SQL Server 只分析语句.当 SET PARSEONLY 为 OFF 时,SQ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y9dja0.html" rel="bookmark">SQL语句学习（一）----通用语法，DDL&comma;DML基础语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1     SQL概述 1.1.1     SQL语句介绍 结构化查询语言(Structured Query Language)简称SQL,是关系型数据库管理系统都需要遵循的规范.不同的数据库生产厂商都支持SQL语句,但都有特有内容. 1.1.2     SQL语句分类 SQL分类: 数据定义语言:简称DDL(Data Definition Language),用来定义数据库对象:数据库,表,列等.关键字:create,alter,drop等 数据操作语言:简称DML(Data Manipu			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPWwv4.html" rel="bookmark" class="title">DropWhile</a>
					<div>
						object DropWhile { def dropWhile[A](l: List[A], f: A =&gt; Boolean): List[A] = l match { case Nil =& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/AMDYD90.html" rel="bookmark" class="title">5&period;4 &dollar;&period;ajax</a>
					<div>
						1.url: 要求为String类型的参数,(默认为当前页地址)发送请求的地址. 2.type: 要求为String类型的参数,请求方式(post或get)默认为get.注意其他http请求方法,例如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5v5X0.html" rel="bookmark" class="title">css基础篇（三）&mdash;&mdash;布局（上）float和position</a>
					<div>
						1.定位(position) position的值有:relative/absolute/fixed/static/inherit; static:为position属性的默认值,static元素会遵 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RBdzy0.html" rel="bookmark" class="title">数据库发包</a>
					<div>
						现在就来看看数据库发包模式 这个用到了抽象工厂模式 其实经理的那个差不多都是注册具体工厂到抽象工厂,只是这里不是抽象工厂而是PktFactoryMgr功能和抽象工厂差不多 { #define __RE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXKWX0.html" rel="bookmark" class="title">页面放大时，发现导航菜单栏背景没有了，但是菜单文字还在，什么原因？</a>
					<div>
						这个问题苦恼了好久!!!百度查了好久都没好办法! 相传很久很久以前,一位隐世高手练成一门绝技,现被我遇到,碎... 帮我解决了这问题 感谢啊.... 如下,菜单栏的一部分,当按住Ctrl +鼠标 放大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLJGXy3.html" rel="bookmark" class="title">用mingw32编译ffmpeg2&period;7</a>
					<div>
						1.  下载x265最新源码: 下载ffmpeg源码(我用的是2.7): 下载cmake最新版本并安装: 下载SDL(我用的SDL-1.2.15): 下载mingw-get-setup.exe,在&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QNvkoM.html" rel="bookmark" class="title">redis 集群热备自动切换sentinel配置实战</a>
					<div>
						Redis SentinelSentinel(哨兵)是用于监控redis集群中Master状态的工具,其已经被集成在redis2.4+的版本中 一.Sentinel作用:1):Master状态检测 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXBR73.html" rel="bookmark" class="title">HDU 1251 统计难题 （字符串-Trie树）</a>
					<div>
						统计难题 Problem Description Ignatius近期遇到一个难题,老师交给他非常多单词(仅仅有小写字母组成,不会有反复的单词出现),如今老师要他统计出以某个字符串为前缀的单词数量(单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dxOzZ0.html" rel="bookmark" class="title">linux常用命令5</a>
					<div>
						网络命令 1. 指令名称:write 指令所在路径:/usr/bin/write 执行权限:所有用户 语法:write  &lt;用户名&gt; 功能描述:给用户发送信息,以Ctrl+D保存结束 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8KOO3.html" rel="bookmark" class="title">网卡添加VLAN TAG</a>
					<div>
						#modprobe 8021q 用命令 lsmod | grep 8021q 来检查 以配置网卡eth0为例,添加vlan号:1002 ================================ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wwOy0.html" rel="bookmark" class="title">Hibernate中的一对一映射关系</a>
					<div>
						Hibernate中的一对一映射关系有两种实现方法(一对一关系:例如一个department只能有一个manager) I使用外键的方式 步骤:1在一对一关联的持久化类中互相添加对方对象属性,   例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZgYw3.html" rel="bookmark" class="title">pig小例1</a>
					<div>
						前提:假如有一批输入数据格式如下: 用户id|文章类别|浏览次数 要求:用pig求出每个用户浏览次数最多的文章类别? 1.首先:读入数据 – 指定分隔符为 “|”– 指定每个字段的类型 进入pig,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElV214.html" rel="bookmark" class="title">android 当ListView滚动时自动调用 onCheckedChanged 导致CheckBox 状态不停变化 的解决办法</a>
					<div>
						今天在做一个含有CheckBox 的ListView时,发现当初始化CheckBox的状态后, 滚动ListView,其中CheckBox 的选中状态不停的发生变化.最后发现原因是 ListView滚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5Vn60.html" rel="bookmark" class="title">XML和JSON解析的区别</a>
					<div>
						XML和JSon是ios解析文件的两种形式, 两种方法各有千秋. 1&gt;. XML分为SAX和DOM两种方式 SAX是按顺序逐行读取文件, 查找到符合条件的内容时就会停止, 而DOM是讲内容一次性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZakm3.html" rel="bookmark" class="title">rtx客户端绿化方法&plus;组织架构更新延迟的解决方案</a>
					<div>
						rtx客户端绿化方法: 1-复制客户端安装目录. 2-运行以下命令,注册dll文件和ocx文件,及rtx程序注册. rtx.exe /regserver ren Config.dll c.d For  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MglQw80.html" rel="bookmark" class="title">SQL Server 创建触发器（trigger）</a>
					<div>
						触发器简介: 触发器是一种特殊的存储过程,它的执行不是由程序调用,也不是手动执行,而是由事件来触发.触发器是当对某一个表进行操作.例如:update.insert.delete这些操作的时候,系统会自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGR2qA4.html" rel="bookmark" class="title">Row&lowbar;number&lpar;&rpar; OVER&lpar;PARTITION BY xxx ORDER BY XXX）分组排序</a>
					<div>
						--//创建一个信息表 CREATE TABLE user_student(id decimal(18,0) identity(1,1),st_name nvarchar(30),class nvar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NnDOB4.html" rel="bookmark" class="title">DataGridView中DataGridViewCheckBoxCell实现反选注意</a>
					<div>
						在DataGridView中使用DataGridViewCheckBoxCell标示哪些行被选中,在菜单中实现了一个反选的功能,即点击的时候,遍历每一行,DataGridViewCheckBoxCel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNvlJ0.html" rel="bookmark" class="title">SQL、LINQ、Lambda 三种用法&lpar;转&rpar;</a>
					<div>
						SQL.LINQ.Lambda 三种用法 颜色注释: SQL LinqToSql Lambda QA 1. 查询Student表中的所有记录的Sname.Ssex和Class列. select sna ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41G1zJ0.html" rel="bookmark" class="title">Android MVP &plus; 泛型，实现了友好VP交互及Activity潜在的内存泄露的优化</a>
					<div>
						Android MVP粗来已经有段时间了,在项目中我也多多少少用了一些,不得不说代码使用这种模式后,条例确实清晰了好多,整个流程看起来有点各司其职的感觉(另一种的java面向对象的方式). 不过这里是 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
